=== debian/changelog ===
kid3 (2.3-2) unstable; urgency=low

  * Upload to unstable 

 -- Mark Purcell <msp@debian.org>  Sat, 11 May 2013 21:00:00 +1000

kid3 (2.3-1) experimental; urgency=low

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 28 Mar 2013 11:23:13 +0100

kid3 (2.2.1-1) experimental; urgency=low

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 07 Dec 2012 10:36:24 +0100

kid3 (2.2-1) experimental; urgency=low

  * New upstream release.
  * Bump Standards-Version to 3.9.4 (no changes needed).
  * Switch to xz compression and add a Pre-Depends on dpkg.
  * Add lintian overrides for false positive hardening-no-fortify-functions
    warnings.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 12 Nov 2012 13:21:29 +0100
